



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MapReduce多用户任务调度器——容量调度器（Capacity Scheduler）原理和源码研究</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MapReduce多用户任务调度器——容量调度器（Capacity Scheduler）原理和源码研究</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 16:39:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><em><strong>前言：为了研究需要，将Capacity Scheduler和Fair Scheduler的原理和代码进行学习，用两篇文章作为记录。如有理解错误之处，欢迎批评指正。</strong></em></p>
<p>容量调度器（Capacity Scheduler）是Yahoo公司开发的多用户调度器。多用户调度器的使用场景很多，根据资料1的说法，Hadoop集群的用户量越来越大，不同用户提交的应用程序具有不同的服务质量要求（QoS）：</p>
<p>1. 批处理作业：耗时较长，对完成时间没有严格要求。如数据挖掘、机器学习等应用。</p>
<p>2. 交互式作业：期望及时返回结果。如Hive等应用。</p>
<p>3. 生产性作业：要求一定量的的资源保证。如统计值计算、垃圾数据分析等。</p>
<p>传统的FIFO调度器不能满足应用对响应时间和资源的多样化要求，多用户多队列调度器应运而生。容量调度器即是其中被广泛应用的一种。</p>
<h2><strong>一、基本思想</strong></h2>
<p>容量调度器以队列为单位划分资源，每个队列都有资源使用的下限和上限。每个用户也可以设定资源使用上限。一个队列的剩余资源可以共享给另一个队列，其他队列使用后还可以归还。管理员可以约束单个队列、用户或作业的资源使用。支持资源密集型作业，可以给某些作业分配多个slot（这是比较特殊的一点）。支持作业优先级，但不支持资源抢占。</p>
<p>这里明确一下用户、队列和作业之间的关系。Hadoop以队列为单位管理资源，每个队列分配到一定的资源，用户只能向一个或几个队列提交作业。队列管理体现为两方面：1. 用户权限管理：<strong>Hadoop用户管理模块建立在操作系统用户和用户组之间的映射之上，允许一个操作系统用户或者用户组对应一个或者多个队列。</strong>同时可以配置每个队列的管理员用户。队列信息配置在mapred-site.xml文件中，包括队列的名称，是否启用权限管理功能等信息，且不支持动态加载。队列权限选项配置在mapred-queue-acls.xml文件中，可以配置某个用户或用户组在某个队列中的某种权限。权限包括作业提交权限和作业管理权限。2. 系统资源管理：管理员可以配置每个队列和每个用户的可用资源量信息，为调度器提供调度依据。这些信息配置在调度器自己的配置文件（如Capacity-Scheduler.xml）中。关于每个配置文件的常见内容见附录。</p>
<h2><strong>二、整体架构</strong></h2>
<p>总体来说，容量调度器的工作流程分5个步骤：</p>
<p>1. 用户提交作业到JobTracker。</p>
<p>2. JobTracker将提交的作业交给Capacity Scheduler的监听器JobQueuesManager，并将作业加入等待队列，由JobInitializationPoller线程初始化。</p>
<p>3. TaskTracker通过心跳信息要求JobTracker为其分配任务。</p>
<p>4. JobTracker调用Capacity Scheduler的assignTasks方法为其分配任务。</p>
<p>5. JobTracker将分配到的任务返回给TaskTracker。</p>
<p>接下，我们结合源代码依次研究上述过程。</p>
<h2>三、<strong>实现细节</strong></h2>
<h3><strong>1. 调度器的启动</strong></h3>
<p>回忆一下，前面谈到调度器启动是由JobTracker调用调度器的start方法实现的，首先来看start方法：</p>
<pre class="prettyprint linenums">    // initialize our queues from the config settings<br />
    if (null == schedConf) {<br />
      schedConf = new CapacitySchedulerConf();<br />
    }</pre>
<p>首先生成配置对象，容量调度器定义了自己的配置对象，构造时会加载调度器自己的配置文件作为资源，并初始化一些默认的配置选项：</p>
<pre class="prettyprint linenums">public CapacitySchedulerConf() {<br />
    rmConf = new Configuration(false);<br />
    rmConf.addResource(SCHEDULER_CONF_FILE);<br />
    initializeDefaults();<br />
  }

private void initializeDefaults() {<br />
    defaultUlimitMinimum =<br />
      rmConf.getInt(<br />
          "mapred.capacity-scheduler.default-minimum-user-limit-percent", 100);<br />
    defaultUserLimitFactor =<br />
      rmConf.getFloat("mapred.capacity-scheduler.default-user-limit-factor",<br />
          1.0f);<br />
    defaultSupportPriority = rmConf.getBoolean(<br />
        "mapred.capacity-scheduler.default-supports-priority", false);<br />
    defaultMaxActiveTasksPerQueueToInitialize =<br />
      rmConf.getInt(<br />
          "mapred.capacity-scheduler.default-maximum-active-tasks-per-queue",<br />
          200000);<br />
    defaultMaxActiveTasksPerUserToInitialize =<br />
      rmConf.getInt(<br />
          "mapred.capacity-scheduler.default-maximum-active-tasks-per-user",<br />
          100000);<br />
    defaultInitToAcceptJobsFactor =<br />
      rmConf.getInt("mapred.capacity-scheduler.default-init-accept-jobs-factor",<br />
          10);<br />
  }</pre>
<p>例如，第一个默认值表示每个用户的最低资源保障，默认为100%。第三个默认值表示是否考虑作业优先级，默认是不考虑。其他配置可以参考资料1中的讲解。接下来，初始化队列信息，队列信息由QueueManager对象获得，该对象的构造过程如下：</p>
<pre class="prettyprint linenums">  public QueueManager(Configuration conf) {<br />
    checkDeprecation(conf);<br />
    conf.addResource(QUEUE_ACLS_FILE_NAME);

    // Get configured ACLs and state for each queue<br />
    aclsEnabled = conf.getBoolean("mapred.acls.enabled", false);

    queues.putAll(parseQueues(conf));<br />
  }

  synchronized private Map&lt;String, Queue&gt; parseQueues(Configuration conf) {<br />
    Map&lt;String, Queue&gt; queues = new HashMap&lt;String, Queue&gt;();<br />
    // First get the queue names<br />
    String[] queueNameValues = conf.getStrings("mapred.queue.names",<br />
        new String[]{JobConf.DEFAULT_QUEUE_NAME});<br />
    for (String name : queueNameValues) {<br />
      Map queueACLs = getQueueAcls(name, conf);<br />
      if (queueACLs == null) {<br />
        LOG.error("The queue, " + name + " does not have a configured ACL list");<br />
      }<br />
      queues.put(name, new Queue(name, getQueueAcls(name, conf),<br />
          getQueueState(name, conf), QueueMetrics.create(name, conf)));<br />
    }

    return queues;<br />
  }</pre>
<p>首先，获取用户权限配置文件mapred-queue-acls.xml。然后通过mapred-site.xml中的配置解析并生成队列的列表queues。解析的过程是，先获取每个队列的名字，再通过名字获取队列的权限配置，最后依据这些信息以及队列状态和队列度量对象构造一个队列并加入结果列表。如上面代码。在初始化队列之前还有构造出每个队列对应的CapacitySchedulerQueue对象：</p>
<pre class="prettyprint linenums">  Map&lt;String, CapacitySchedulerQueue&gt;<br />
  parseQueues(Collection&lt;String&gt; queueNames, CapacitySchedulerConf schedConf)<br />
  throws IOException {<br />
    Map&lt;String, CapacitySchedulerQueue&gt; queueInfoMap =<br />
      new HashMap&lt;String, CapacitySchedulerQueue&gt;();

    // Sanity check: there should be at least one queue.<br />
    if (0 == queueNames.size()) {<br />
      throw new IllegalStateException("System has no queue configured");<br />
    }

    float totalCapacityPercent = 0.0f;<br />
    for (String queueName: queueNames) {<br />
      float capacityPercent = schedConf.getCapacity(queueName);<br />
      if (capacityPercent == -1.0) {<br />
        throw new IOException("Queue '" + queueName +<br />
            "' doesn't have configured capacity!");<br />
      } 

      totalCapacityPercent += capacityPercent;

      // create our Queue and add to our hashmap<br />
      CapacitySchedulerQueue queue =<br />
        new CapacitySchedulerQueue(queueName, schedConf);<br />
      queueInfoMap.put(queueName, queue);<br />
    }

    if (Math.floor(totalCapacityPercent) != 100) {<br />
      throw new IllegalArgumentException(<br />
        "Sum of queue capacities not 100% at "<br />
          + totalCapacityPercent);<br />
    }    

    return queueInfoMap;<br />
  }</pre>
<p>容量调度器队列对象被装入一个以队列名为键的map中返回并用于初始化。获取队列后要进行初始化，由函数initialize完成：</p>
<pre class="prettyprint linenums">    void initialize(QueueManager queueManager,<br />
      Map&lt;String, CapacitySchedulerQueue&gt; newQueues,<br />
      Configuration conf, CapacitySchedulerConf schedConf) {<br />
    // Memory related configs<br />
    initializeMemoryRelatedConf(conf);

    // Setup queues<br />
    for (Map.Entry&lt;String, CapacitySchedulerQueue&gt; e : newQueues.entrySet()) {<br />
      String newQueueName = e.getKey();<br />
      CapacitySchedulerQueue newQueue = e.getValue();<br />
      CapacitySchedulerQueue currentQueue = queueInfoMap.get(newQueueName);<br />
      if (currentQueue != null) {<br />
        currentQueue.initializeQueue(newQueue);<br />
        LOG.info("Updated queue configs for " + newQueueName);<br />
      } else {<br />
        queueInfoMap.put(newQueueName, newQueue);<br />
        LOG.info("Added new queue: " + newQueueName);<br />
      }<br />
    }

    // Set SchedulingDisplayInfo<br />
    for (String queueName : queueInfoMap.keySet()) {<br />
      SchedulingDisplayInfo schedulingInfo =<br />
        new SchedulingDisplayInfo(queueName, this);<br />
      queueManager.setSchedulerInfo(queueName, schedulingInfo);<br />
    }

    // Inform the queue manager<br />
    jobQueuesManager.setQueues(queueInfoMap);

    // let our mgr objects know about the queues<br />
    mapScheduler.initialize(queueInfoMap);<br />
    reduceScheduler.initialize(queueInfoMap);

    // scheduling tunables<br />
    maxTasksPerHeartbeat = schedConf.getMaxTasksPerHeartbeat();<br />
    maxTasksToAssignAfterOffSwitch =<br />
      schedConf.getMaxTasksToAssignAfterOffSwitch();<br />
  }</pre>
<p>具体过程如下：首先根据配置对象初始化跟内存相关的一些变量；然后检查某个队列是否在queueInfoMap数据结构中，若在，就更新队列信息，若不在，则加入其中，该数据结构提供了一个快速通过队列名访问队列的途径；接下来设置每个队列的调度信息用于展示或日志；然后将队列map交给监听器对象JobQueuesMananger；接着，将队列信息再交给map和reduce调度器对象，每个调度器对象维护了可以获取任务的队列列表，用于调度时的队列选择；最后设置批量任务分配的最大数量。</p>
<p>上述过程中，用于不同任务调度的mapScheduler和reduceScheduler值得进一步研究。队列会被加入到map或reduce调度器的优先级队列中：</p>
<pre class="prettyprint linenums">     queuesForAssigningTasks.clear();<br />
     queuesForAssigningTasks.addAll(queues.values());<br />
     Collections.sort(queuesForAssigningTasks, queueComparator);</pre>
<p>队列的优先级由queueComparator定义，map和reduce的比较器实现基本相同，只是任务类型不同：</p>
<pre class="prettyprint linenums">     public int compare(CapacitySchedulerQueue q1, CapacitySchedulerQueue q2) {<br />
        // look at how much capacity they've filled. Treat a queue with<br />
        // capacity=0 equivalent to a queue running at capacity<br />
        TaskType taskType = getTaskType();<br />
        double r1 = (0 == q1.getCapacity(taskType))? 1.0f:<br />
          (double)q1.getNumSlotsOccupied(taskType)/(double) q1.getCapacity(taskType);<br />
        double r2 = (0 == q2.getCapacity(taskType))? 1.0f:<br />
          (double)q2.getNumSlotsOccupied(taskType)/(double) q2.getCapacity(taskType);<br />
        if (r1&lt;r2) return -1;<br />
        else if (r1&gt;r2) return 1;<br />
        else return 0;<br />
      }</pre>
<p>上述compare方法的实现表明，队列的资源使用率越高，在队列列表中的顺序越靠后，优先级越低。也就是说，Capacity Scheduler总是选择资源利用率最低的队列。至此，队列初始化分析完毕。</p>
<p>接下来，调度器将监听器对象注册到JobTracker：</p>
<pre class="prettyprint linenums">    // listen to job changes<br />
    taskTrackerManager.addJobInProgressListener(jobQueuesManager);</pre>
<p>然后启动初始化线程：</p>
<pre class="prettyprint linenums">    //Start thread for initialization<br />
    if (initializationPoller == null) {<br />
      this.initializationPoller = new JobInitializationPoller(<br />
          jobQueuesManager, schedConf, queueNames, taskTrackerManager);<br />
    }<br />
    initializationPoller.init(queueNames.size(), schedConf);<br />
    initializationPoller.setDaemon(true);<br />
    initializationPoller.start();</pre>
<p>初始化线程initializationPoller是个后台线程。init方法为每个队列指定一个初始化线程，线程总数总是小于或等于队列的数量。然后启动每个初始化线程。 <br /> 最后设置用于显示调度器信息的Servlet：</p>
<pre class="prettyprint linenums">    if (taskTrackerManager instanceof JobTracker) {<br />
      JobTracker jobTracker = (JobTracker) taskTrackerManager;<br />
      HttpServer infoServer = jobTracker.infoServer;<br />
      infoServer.setAttribute("scheduler", this);<br />
      infoServer.addServlet("scheduler", "/scheduler",<br />
          CapacitySchedulerServlet.class);<br />
    }</pre>
<p>至此，调度器启动完毕。</p>
<h3><strong>2. 作业初始化</strong></h3>
<p>由于初始化的作业不能得到调度会占用过多内存，容量调度器通过两种策略初始化作业：1. 优先初始化最可能被调度器调度的作业；2. 限制用户初始化作业数目。详细过程如下：作业被提交到JobTracker后，调度器的监听器调用jobAdded方法：</p>
<pre class="prettyprint linenums">    // add job to the right queue<br />
    CapacitySchedulerQueue queue = getQueue(job.getProfile().getQueueName());</pre>
<p>这条语句将作业加入对应的队列中。接下来调用队列的addWaitingJob方法：</p>
<pre class="prettyprint linenums">    synchronized void addWaitingJob(JobInProgress job) throws IOException {<br />
    JobSchedulingInfo jobSchedInfo = new JobSchedulingInfo(job);

    String user = job.getProfile().getUser();

    // Check acceptance limits<br />
    checkJobSubmissionLimits(job, user);

    waitingJobs.put(jobSchedInfo, job);

    // Update user stats<br />
    UserInfo userInfo = users.get(user);<br />
    if (userInfo == null) {<br />
      userInfo = new UserInfo(comparator);<br />
      users.put(user, userInfo);<br />
    }<br />
    userInfo.jobAdded(jobSchedInfo, job);<br />
  }</pre>
<p>在该方法中，首先生成调度信息对象，此对象与默认的FIFO调度器的调度信息对象一样。然后检查三个约束：</p>
<p>1. 作业的任务数是否超过每个用户最大任务数</p>
<pre class="prettyprint linenums">    if (job.desiredTasks() &gt; maxActiveTasksPerUser) {<br />
      throw new IOException(<br />
          "Job '" + job.getJobID() + "' from user '" + user  +<br />
          "' rejected since it has " + job.desiredTasks() + " tasks which" +<br />
          " exceeds the limit of " + maxActiveTasksPerUser +<br />
          " tasks per-user which can be initialized for queue '" +<br />
          queueName + "'"<br />
          );<br />
    }</pre>
<p>2. 队列中等待初始化、已经初始化的作业数目和在运行的作业数不能超过可接受值</p>
<pre class="prettyprint linenums">// Across all jobs in queue<br />
    int queueWaitingJobs = getNumWaitingJobs();<br />
    int queueInitializingJobs = getNumInitializingJobs();<br />
    int queueRunningJobs = getNumRunningJobs();<br />
    if ((queueWaitingJobs + queueInitializingJobs + queueRunningJobs) &gt;=<br />
      maxJobsToAccept) {<br />
      throw new IOException(<br />
          "Job '" + job.getJobID() + "' from user '" + user  +<br />
          "' rejected since queue '" + queueName +<br />
          "' already has " + queueWaitingJobs + " waiting jobs, " +<br />
          queueInitializingJobs + " initializing jobs and " +<br />
          queueRunningJobs + " running jobs - Exceeds limit of " +<br />
          maxJobsToAccept + " jobs to accept");<br />
    }</pre>
<p>3. 用户等待初始化、已经初始化和在运行的作业数不能超过可接受值</p>
<pre class="prettyprint linenums">    // Across all jobs of the user<br />
    int userWaitingJobs = getNumWaitingJobsByUser(user);<br />
    int userInitializingJobs = getNumInitializingJobsByUser(user);<br />
    int userRunningJobs = getNumRunningJobsByUser(user);<br />
    if ((userWaitingJobs + userInitializingJobs + userRunningJobs) &gt;=<br />
        maxJobsPerUserToAccept) {<br />
      throw new IOException(<br />
          "Job '" + job.getJobID() + "' rejected since user '" + user +<br />
          "' already has " + userWaitingJobs + " waiting jobs, " +<br />
          userInitializingJobs + " initializing jobs and " +<br />
          userRunningJobs + " running jobs - " +<br />
          " Exceeds limit of " + maxJobsPerUserToAccept + " jobs to accept" +<br />
          " in queue '" + queueName + "' per user");<br />
    }</pre>
<p>若有一个约束不满足，则抛出异常。否则将作业加入等待初始化队列。最后调用调度器的jobAdded方法通知调度器：</p>
<pre class="prettyprint linenums">  // called when a job is added<br />
  synchronized void jobAdded(JobInProgress job) throws IOException {<br />
    CapacitySchedulerQueue queue =<br />
      queueInfoMap.get(job.getProfile().getQueueName());

    // Inform the queue<br />
    queue.jobAdded(job);

    // setup scheduler specific job information<br />
    preInitializeJob(job);<br />
  }</pre>
<p>首先获取队列，然后告诉队列有作业加入，并将队列中提交该作业的用户的作业数更新。最后依据配置计算每个任务需要的slot数目（容量调度器支持大内存作业）。</p>
<p>作业初始化线程的入口在JobInitializationPoller（以下简称poller）的run方法。</p>
<pre class="prettyprint linenums">  public void run() {<br />
    while (running) {<br />
      try {<br />
        cleanUpInitializedJobsList();<br />
        selectJobsToInitialize();<br />
        if (!this.isInterrupted()) {<br />
          Thread.sleep(sleepInterval);<br />
        }<br />
      } catch (InterruptedException e) {<br />
        LOG.error("Job Initialization poller interrupted"<br />
            + StringUtils.stringifyException(e));<br />
      }<br />
    }<br />
  }</pre>
<p>在该方法中，首先从initializedJobs数据结构中清除一些作业，这些作业是正在运行且获得调度的作业或者是运行完成的作业。接着，调用selectJobsToInitialize方法来选择等待初始化的作业。具体过程如下，对于每个队列，首先选择该队列中处于waitingJobs列表中的作业：</p>
<pre class="prettyprint linenums">ArrayList&lt;JobInProgress&gt; jobsToInitialize = getJobsToInitialize(queue);</pre>
<p>选择的原则是：一看该作业是否已经初始化；若不是，二检查队列中作业总数（正在运行和正在初始化）和允许的活动任务数是否超过上限；若没有，检查提交该作业的用户是不是有过多的作业（正在运行和正在初始化）或活动的任务；若仍不是，则进一步检查作业是否处于PREP状态（没有被kill掉），然后放入筛选结果列表，并通知所在队列，将其放入initializingJobs列表。以上过程详见getJobsToInitialized方法的实现，这里不赘述。</p>
<p>下面获取一个分配给该队列的初始化线程，并将选择初始化的作业加入属于相应队列的调度列表中：</p>
<pre class="prettyprint linenums">    JobInitializationThread t = threadsToQueueMap.get(queue);<br />
      for (JobInProgress job : jobsToInitialize) {<br />
        t.addJobsToQueue(queue, job);<br />
    }</pre>
<p>每个初始化线程维护了一个map（jobsPerQueue），通过队列名字可以找到由该线程初始化的队列的作业调度列表。 <br /> 最后，我们来看初始化线程JobInitializationThread的run方法，该方法中不停地调用initializeJobs方法：</p>
<pre class="prettyprint linenums">     void initializeJobs() {<br />
      // while there are more jobs to initialize...<br />
      while (currentJobCount.get() &gt; 0) {<br />
        Set&lt;String&gt; queues = jobsPerQueue.keySet();<br />
        for (String queue : queues) {<br />
          JobInProgress job = getFirstJobInQueue(queue);<br />
          if (job == null) {<br />
            continue;<br />
          }<br />
          LOG.info("Initializing job : " + job.getJobID() + " in Queue "<br />
              + job.getProfile().getQueueName() + " For user : "<br />
              + job.getProfile().getUser());<br />
          if (startIniting) {<br />
            setInitializingJob(job);<br />
            ttm.initJob(job);<br />
            setInitializingJob(null);<br />
          } else {<br />
            break;<br />
          }<br />
        }<br />
      }<br />
    }</pre>
<p>从代码可见，获取队列中第一个作业，将其交给JobTracker的initJob初始化，初始化详细过程见前面的一系列文章。至此，容量调度器的作业初始化过程分析完毕。</p>
<p>作为该小节的结束，这里说一下每个队列中维护的几个数据结构：</p>
<pre class="prettyprint linenums">    this.waitingJobs =<br />
      new TreeMap&lt;JobSchedulingInfo, JobInProgress&gt;(comparator);<br />
    this.initializingJobs =<br />
      new TreeMap&lt;JobSchedulingInfo, JobInProgress&gt;(comparator);<br />
    this.runningJobs =<br />
      new TreeMap&lt;JobSchedulingInfo, JobInProgress&gt;(comparator);</pre>
<p>正如名称暗示的那样，三个列表分别持有等待初始化的作业、正在初始化的作业和正在运行的作业。它们共有的参数为一个Comparator对象，用于定义列表中作业的顺序。 <br /> 它的初始化如下：</p>
<pre class="prettyprint linenums">    if (supportsPriorities) {<br />
      // use the default priority-aware comparator<br />
      comparator = JobQueueJobInProgressListener.FIFO_JOB_QUEUE_COMPARATOR;<br />
    }<br />
    else {<br />
      comparator = STARTTIME_JOB_COMPARATOR;<br />
    }</pre>
<p>如果调度器支持优先级，则比较器对象初始化为FIFO调度器中的FIFO比较器，原则是首先比较优先级，再比较开始时间，最后比较作业ID。如果调度器不支持优先级，则初始化为开始时间比较器，即先来先服务。</p>
<p>初始化线程会从waitingJobs列表中选择要初始化的作业，被选择的作业会放入initializingJobs列表，初始化后得到调度的作业会进入runningJobs列表。有关作业的调度见下一小节。</p>
<h3>3. 任务调度</h3>
<p>容量调度器采用三层调度模型：首先选择一个队列，其次选择一个作业，最后选择作业的任务。任务选择由调度器的assignTasks方法完成，下面详述该方法。</p>
<p>首先调用下面方法更新各个队列的资源使用信息：</p>
<pre class="prettyprint linenums">updateAllQueues(mapClusterCapacity, reduceClusterCapacity);</pre>
<p>具体到每个队列中，调用队列的updateAll方法。</p>
<p>首先更新队列最新的map和reduce资源量：</p>
<pre class="prettyprint linenums">    // Compute new capacities for maps and reduces<br />
    mapSlots.updateCapacities(capacityPercent, maxCapacityPercent,<br />
        mapClusterCapacity);<br />
    reduceSlots.updateCapacities(capacityPercent, maxCapacityPercent,<br />
        reduceClusterCapacity);</pre>
<p>接下来将以下信息更新到每个作业的调度信息对象中：</p>
<pre class="prettyprint linenums">    j.setSchedulingInfo(<br />
          CapacityTaskScheduler.getJobQueueSchedInfo(numMapsRunningForThisJob,<br />
              numRunningMapSlots,<br />
              numReservedMapSlotsForThisJob,<br />
              numReducesRunningForThisJob,<br />
              numRunningReduceSlots,<br />
              numReservedReduceSlotsForThisJob));</pre>
<p>包括：作业正在运行的map和reduce作业数，作业正在使用的map和reduce资源数和为这个作业保留的map和reduce资源数。</p>
<p>然后将每个作业的资源使用信息反映到该作业所在队列的相关信息中：</p>
<pre class="prettyprint linenums">    update(TaskType.MAP, j, j.getProfile().getUser(),<br />
          numMapsRunningForThisJob, numMapSlotsForThisJob);<br />
    update(TaskType.REDUCE, j, j.getProfile().getUser(),<br />
          numReducesRunningForThisJob, numReduceSlotsForThisJob);</pre>
<p>包括队列中正在运行的任务数，正在使用的资源量和用户使用的资源量等信息。</p>
<p>更新后，通过addMapTasks和addReduceTask两个方法调度任务：</p>
<pre class="prettyprint linenums">    // schedule tasks<br />
    List&lt;Task&gt; result = new ArrayList&lt;Task&gt;();<br />
    addMapTasks(taskTracker, result, maxMapSlots, currentMapSlots);<br />
    addReduceTask(taskTracker, result, maxReduceSlots, currentReduceSlots);</pre>
<p>关于队列和作业的优先级前面已经提到，这里关注任务的优先顺序。在addMapTasks方法中，调用CapacityScheduler的assignTasks方法：</p>
<pre class="prettyprint linenums">    JobInProgress job = taskTracker.getJobForFallowSlot(type);<br />
      if (job != null) {<br />
        if (availableSlots &gt;= job.getNumSlotsPerTask(type)) {<br />
          // Unreserve<br />
          taskTracker.unreserveSlots(type, job);

          // We found a suitable job. Get task from it.<br />
          if (type == TaskType.MAP) {<br />
            // Don't care about locality!<br />
            job.overrideSchedulingOpportunities();<br />
          }<br />
          return obtainNewTask(taskTrackerStatus, job, true);<br />
        } else {<br />
          // Re-reserve the current tasktracker<br />
          taskTracker.reserveSlots(type, job, availableSlots);

          return TaskLookupResult.getMemFailedResult();<br />
        }<br />
      }</pre>
<p>首先，判断TaskTracker是否正为某个作业预留资源（该作业为内存密集型，一个任务可能需要多个slot，上次调度没有足够的slot分配，故将其预留给该作业用于下次调度。这是容量调度器的大内存任务调度机制），若有预留，则判断当前可用的资源是否能满足该作业，若能则不再预留资源，并调用obtainNewTask方法将资源分配给该作业执行；若不能，继续将当前资源预留给该作业，并返回内存失败的结果。</p>
<p>如果TaskTracker没有为某个作业预留资源，对于队列集合中的每个队里，从中选择一个作业，并调用obtainNewTask方法获得一个任务。当遇到当前可用资源不能满足一个任务时，也要预留资源。注意，每次获取一个任务都会返回获取的状态，代码如下：</p>
<pre class="prettyprint linenums">    for (CapacitySchedulerQueue queue : queuesForAssigningTasks) {<br />
        //This call is for optimization if we are already over the<br />
        //maximum-capacity we avoid traversing the queues.<br />
        if (!queue.assignSlotsToQueue(type, 1)) {<br />
          continue;<br />
        }

        TaskLookupResult tlr =<br />
          getTaskFromQueue(taskTracker, availableSlots, queue, assignOffSwitch);<br />
        TaskLookupResult.LookUpStatus lookUpStatus = tlr.getLookUpStatus();

        if (lookUpStatus == TaskLookupResult.LookUpStatus.NO_TASK_FOUND) {<br />
          continue; // Look in other queues.<br />
        }

        // if we find a task, return<br />
        if (lookUpStatus == TaskLookupResult.LookUpStatus.LOCAL_TASK_FOUND ||<br />
            lookUpStatus == TaskLookupResult.LookUpStatus.OFF_SWITCH_TASK_FOUND) {<br />
          return tlr;<br />
        }<br />
        // if there was a memory mismatch, return<br />
        else if (lookUpStatus ==<br />
          TaskLookupResult.LookUpStatus.TASK_FAILING_MEMORY_REQUIREMENT) {<br />
            return tlr;<br />
        }<br />
      }</pre>
<p>最后来分析一下，获取任务的核心方法obtainNewTask：</p>
<pre class="prettyprint linenums">    TaskLookupResult obtainNewTask(TaskTrackerStatus taskTracker,<br />
                                   JobInProgress job, boolean assignOffSwitch)<br />
    throws IOException {<br />
      ClusterStatus clusterStatus =<br />
        scheduler.taskTrackerManager.getClusterStatus();<br />
      int numTaskTrackers = clusterStatus.getTaskTrackers();<br />
      int numUniqueHosts = scheduler.taskTrackerManager.getNumberOfUniqueHosts();

      // Inform the job it is about to get a scheduling opportunity<br />
      job.schedulingOpportunity();

      // First, try to get a 'local' task<br />
      Task t = job.obtainNewNodeOrRackLocalMapTask(taskTracker,<br />
                                                   numTaskTrackers,<br />
                                                   numUniqueHosts);

      if (t != null) {<br />
        return TaskLookupResult.getTaskFoundResult(t, job);<br />
      }

      // Next, try to get an 'off-switch' task if appropriate<br />
      // Do not bother as much about locality for High-RAM jobs<br />
      if (job.getNumSlotsPerMap() &gt; 1 ||<br />
          (assignOffSwitch &amp;&amp;<br />
              job.scheduleOffSwitch(numTaskTrackers))) {<br />
        t =<br />
          job.obtainNewNonLocalMapTask(taskTracker, numTaskTrackers, numUniqueHosts);<br />
      }

      return (t != null) ?<br />
          TaskLookupResult.getOffSwitchTaskFoundResult(t, job) :<br />
          TaskLookupResult.getNoTaskFoundResult();<br />
    }</pre>
<p>与FIFO调度器的实现类似，首先也要试图找到一个具有数据本地新的任务。若没找到，则分配一个内存密集型任务或off-switch的任务。具体的分配过程参见前面的文章对FIFO任务调度的分析（ <a href="http://blog.csdn.net/jaytalent/article/details/11643475" rel="external nofollow noreferrer">MapReduce任务调度与执行原理之任务调度</a>）。若仍然没有找到，则返回没有找到结果。</p>
<p>如果获取到的任务数达到一次心跳返回的任务最大数量，则返回：</p>
<pre class="prettyprint linenums">    if (tasks.size() &gt;= maxTasksPerHeartbeat) {<br />
        return;<br />
      }</pre>
<p>为了尽量提高任务的数据本地性，容量调度器采用了作业延迟调度机制：如果一个作业中未找到满足数据本地性的任务，则会让该作业跳过一定数目的机会，直到找到一个满足数据本地性的任务或到达跳过次数上限。</p>
<pre class="prettyprint linenums">    if (job.getNumSlotsPerMap() &gt; 1 ||<br />
          (assignOffSwitch &amp;&amp;<br />
              job.scheduleOffSwitch(numTaskTrackers))) {<br />
        t =<br />
          job.obtainNewNonLocalMapTask(taskTracker, numTaskTrackers, numUniqueHosts);<br />
      }</pre>
<p>assignOffSwitch为true表示还未分配过不具有数据本地性的任务，scheduleOffSwitch用于判断作业是否到达跳过次数上限：</p>
<pre class="prettyprint linenums">  public boolean scheduleOffSwitch(int numTaskTrackers) {<br />
    long missedTaskTrackers = getNumSchedulingOpportunities();<br />
    long requiredSlots =<br />
      Math.min((desiredMaps() - finishedMaps()), numTaskTrackers);

    return (requiredSlots  * localityWaitFactor) &lt; missedTaskTrackers;<br />
  }</pre>
<p>localityWaitFactor表示作业输入数据所在结点数占结点总数的比例，requiredSlots表示作业还需要的资源数，二者的乘积来衡量跳过次数的上限，而missedTaskTrackers即为跳过次数。missedTaskTrackers每次分配任务时都会增加，如果分配到本地任务，则返回任务，该变量会重置为0；若没有分配到，则表示跳过一次。在分配到非本地性任务后跳过次数也会重置为0。</p>
<p>reduce任务的分配机制相对简单，只采用了大内存任务调度策略，调度器只要找到一个合适的reduce任务即返回，且没有延迟调度。至此，容量调度器任务调度分析结束。</p>
<p>下一篇文章计划学习Fair Scheduler。如有错误和问题，欢迎批评指正。</p>
<h2>参考资料</h2>
<div>
   【1】《Hadoop技术内幕--深入解析MapReduce架构设计与实现原理》董西成
 </div>
<div>
   【2】 &nbsp;Hadoop 1.0.0 源码
 </div>
<p><strong>2013年10月7日</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gzpkl8.html">解决SQL server 2014 修改表中的字段，无法保存的问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq46v5n8.html">Sonatype Nexus Maven仓库搭建和管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvl5pj8.html">python 列表生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmevo69.html">pycharm如何调试scrapy</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yywk5q.html">SpringMVC--xxx&period;xml配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okdvx59.html">POJ3469 Dual Core CPU&lpar;最小割&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydog6jq.html">关于php的两个符号&commat;和&dollar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnjl0v8.html">Android开发&lowbar;后台任务task管理&lowbar;allowTaskReparenting alwaysRetainTaskState clearTaskOn</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wz5klq.html">iOS程序-UIScrollView的基本使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o65xj9.html">大写String和小写string的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meg646q.html">「2017 山东三轮集训 Day1」Flair</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw0vxx9.html">FTP软件FileZilla 3&period;38&period;1下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdry39.html">Django的contenttypes</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2517moq.html">收藏住：金融&amp;amp&semi;电商类原型模板重磅来袭，免费使用！</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4glle9.html">关于 EF 对象的创建问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1er3eq.html">IDEA 热部署- 自动编译设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g65gzq.html">centos 安装oracle 11g r2（三）-----表空间创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/963j52v9.html">Android 使用第三方登录（QQ和新浪微博）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em41xz9.html">TortoiseGit使用指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em4ldk9.html">hive元数据研究</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvvwy5xq.html">SQL 优化，全</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okr64l9.html">服务端配置scan ip</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v534n8.html">IOS开发网络篇之&HorizontalLine;&HorizontalLine;ASIHTTPRequest详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y1lkeq.html">SGU 125&period;Shtirlits</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w1oxoq.html">yum安装ftp服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x1e6g9.html">ios开发之代理&amp;amp&semi;&amp;amp&semi;协议</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm0yj69.html">form WebBrowser自动点击弹出提示框alert、弹出对话框confirm、屏蔽弹出框、屏蔽弹出脚本错误的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn7eepq.html">ExtJS 4 Grids 详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn7e2rq.html">Unity图片处理类，包括压缩、截屏和滤镜</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wlj2oq.html">未能加载文件或程序集XXX或它的某一个依赖项。试图加载格式不正确的程序。</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
